<?php
/**
* SEF advance component extension
*
* This extension will give the SEF advance style URLs to the example component
* Place this file (sef_ext.php) in the main component directory
* Note that class must be named: sef_componentname
*
* Copyright (C) 2003-2004 Emir Sakic, http://www.sakic.net, All rights reserved.
*
* Comments: for SEF Advance > v3.6
*
* Extension for
* -------------
* Component : Business Directory
* Author    : Waseem Sadiq - www.meesaw.com
* Version   : 1.0
* Date      : 29.09.2004
**/

class sef_business_directory {

   // ********************** DB Primitives ****************************

    var $defmode;

    function sef_business_directory() {    // Class Initialization (!?!?)...
      global $database;
      $database->setQuery( "SELECT value"
                      . "\n FROM #__business_directory_prefs"
                      . "\n WHERE userid='-1'"
                      . "\n AND category='params'"
                      . "\n AND name='displaymode'"
      );

      $database->loadObject($row);
      if ( $row ) {
          $this->defmode = $row->value;
        } else {
          $this->defmode = "0";
        }

    }


   function getBMTitle ($id) {
     global $database,$_SEF_SPACE;

     $database->setQuery( "SELECT b.title"
                     . "\n FROM #__business_directory as b"
                     . "\n WHERE b.id = $id"
     );
     $title = $database->loadResult();
     $title = str_replace(" ",$_SEF_SPACE,$title);     // Replace space with underscore

//echo "DEBUG: GetBMTile [$id] => [$title]<br />\n";
     return $title;
   }

   function getBMid ($title) {
     global $database,$_SEF_SPACE;

     $title = urldecode($title);                       // convert "%xx" to its real char
     $title = str_replace($_SEF_SPACE," ",$title);     // Replace underscore with space

     $database->setQuery( "SELECT b.id"
                     . "\n FROM #__business_directory as b"
                     . "\n WHERE b.title = '$title'"
     );
     $id = $database->loadResult();

//echo "DEBUG: GetBMtId [$title] => [$id]<br />\n";
     return $id;
   }

   function getCatTitle ($id) {
     global $database,$_SEF_SPACE;

     $database->setQuery( "SELECT c.name"
                     . "\n FROM #__business_directory_categories as c"
                     . "\n WHERE c.id = '$id'"
     );
     $title = $database->loadResult();

     $title = str_replace(" / ","+",$title);           // replace the " / " sub-categoires separator to pipe "|" to avoid categories and parameters separator confusion.
     $title = str_replace(" ",$_SEF_SPACE,$title);     // Replace space with underscore

// echo "DEBUG: GetCatTitle [$id] => [$title]<br />\n";
     return $title;
   }

   function getCatid ($title) {
     global $database,$_SEF_SPACE;


     $title = str_replace("+"," / ",$title);           // replace the " / " sub-categoires separator to pipe "|" to avoid categories and parameters separator confusion.
     $title = urldecode($title);                       // convert "%xx" to its real char
     $title = str_replace($_SEF_SPACE," ",$title);     // Replace underscore with space

     $database->setQuery( "SELECT c.id"
                     . "\n FROM #__business_directory_categories as c"
                     . "\n WHERE c.name = '$title'"
     );
     $id = $database->loadResult();
     if (!$id) { $id = -1; }  // Not found => Back to Root (-1)

// echo "DEBUG: GetCatId [$title] => [$id]<br />\n";
     return $id;
   }


   function getMode ($id) {
     switch ($id) {
       case "1" :
         $mode = "byalpha";
         break;
       case "2" :
         $mode = "bycats";
         break;
       case "3" :
         $mode = "allalpha";
         break;
       case "0" :
         $mode = "onecat";
         break;
       default:
         $mode = "";
     }

//echo "DEBUG: GetMode [$id] => [$mode]<br />\n";
     return $mode;
   }


   function getModeid ($mode) {
     switch ($mode) {
       case "byalpha" :
           $id = "1";
           break;
       case "bycats" :
           $id = "2";
           break;
       case "allalpha" :
           $id = "3";
           break;
       case "onecat" :
         $id = "0";
       default :
         $id = "0";
     }

//echo "DEBUG: GetModeid [$mode] => [$id]<br />\n";
     return $id;
   }


   // ********************** TOOLBOX ****************************


   function getVal (&$string, $varname, $default) {

     $string = str_replace("&amp;","&",$string);    // replace "&amp;" with "&" for explore routine...
     $vars = explode("&", $string);
     $temp = array();
     $i=0;
     foreach ($vars as $var) {
        $temp = explode("=", $var);
        if ($temp[0] == $varname) {  // Found the variable
           break;
        }
        $i++;
     }
     if ($temp[0] != $varname) { // Not found => Set Default values
        $temp[0] = $varname;
        $temp[1] = $default;
     }

     switch ($varname) {  // Convert id to text or other special values
       case "id" :
           $temp[1] = sef_business_directory::getBMTitle($temp[1]);
           break;
       case "catid" :
           $temp[1] = sef_business_directory::getCatTitle($temp[1]);
           break;
       case "mode" :
           $temp[1] = sef_business_directory::getMode($temp[1]);
           break;
       case "search" :
           $temp[1] = ($temp[1]=='*') ? 'all_items' : $temp[1];    // Remove the ugly star "*" (search filter) and convert it to something more "readable"...
           break;
       default :
     }

/*
foreach ($temp as $z=>$x) {
  echo "DEBUG <b>Temp!</b> : $z: $x<br />\n";
}
*/

     return $temp[1];
   }


   /**
   * Convert a parameter (var) to SEF format
   * Input: $varname, string, The parameter name
   * Output: $sefstring, string, The variable converted to SEF format ($varname/)
   **/
   function extractVar (&$string, &$tsk, $varname) {
     global $database, $lowercase;

     $sefstring = "";
     $convert = "";

     if ($varname == "task") {
        $convert = sef_business_directory::getVal($string, 'task', 'list');
        $tsk = $convert;
     } else {
        switch ($tsk) {

          case "list" :
              if ( $varname == 'mode' )     { $convert = sef_business_directory::getVal( $string, 'mode',     $this->defmode ); }
              if ( $varname == 'catid' )    { $convert = sef_business_directory::getVal( $string, 'catid',    '-1' ); }
              if ( $varname == 'navstart' ) { $convert = sef_business_directory::getVal( $string, 'navstart', '0' ); }
              if ( $varname == 'search' )   { $convert = sef_business_directory::getVal( $string, 'search',   '' ); }
              if ( $varname == 'msg' )      { $convert = sef_business_directory::getVal( $string, 'msg',      '' ); }
              break;

          case "view" :
              if ( $varname == 'id' )       { $convert = sef_business_directory::getVal( $string, 'id',       '0' ); }
              break;

          case "check" :
          case "detail" :
          case "edit" :
          case "recommend" :
          case "recommendd" :
          case "send" :
          case "sendd" :
          case "wrapper" :
              if ( $varname == 'id' )       { $convert = sef_business_directory::getVal( $string, 'id',       '0' ); }
              if ( $varname == 'mode' )     { $convert = sef_business_directory::getVal( $string, 'mode',     $this->defmode ); }
              if ( $varname == 'catid' )    { $convert = sef_business_directory::getVal( $string, 'catid',    '0' ); }
              if ( $varname == 'navstart' ) { $convert = sef_business_directory::getVal( $string, 'navstart', '0' ); }
              if ( $varname == 'search' )   { $convert = sef_business_directory::getVal( $string, 'search',   '' ); }
              break;

          case "order" :
              if ( $varname == 'mode' )          { $convert = sef_business_directory::getVal( $string, 'mode',   $this->defmode ); }
              if ( $varname == 'catid' )         { $convert = sef_business_directory::getVal( $string, 'catid',  '0' ); }
              if ( $varname == 'orderbycol' )    { $convert = sef_business_directory::getVal( $string, 'orderbycol', 'title' ); }
              if ( $varname == 'orderbyupdown' ) { $convert = sef_business_directory::getVal( $string, 'orderbyupdown', 'asc' ); }
              if ( $varname == 'search' )        { $convert = sef_business_directory::getVal( $string, 'search', '' ); }
              break;

          case "new" :
          case "cancel" :
          case "save" :
              if ( $varname == 'mode' )     { $convert = sef_business_directory::getVal( $string, 'mode',     $this->defmode ); }
              if ( $varname == 'catid' )    { $convert = sef_business_directory::getVal( $string, 'catid',    '0' ); }
              if ( $varname == 'navstart' ) { $convert = sef_business_directory::getVal( $string, 'navstart', '0' ); }
              if ( $varname == 'search' )   { $convert = sef_business_directory::getVal( $string, 'search',   '' ); }
              break;

          default :
        }
     }

     if ($convert != "") {
        if ($lowercase) {     // $lowercase is retrieved from the SEFAdvance main parameters
           $sefstring .= strtolower($convert) ."/";
        } else {
           $sefstring .= $convert ."/";
        }
     }

     return $sefstring;
   }


  function  setVar($value, &$var, $varname) {
     global $_GET, $_REQUEST;       // Mandatory : Need to access to gobal Link (Request) and Posted (GET) Mambo data

     switch ($varname) {  // Convert some special values
       case "search" :
//echo "DEBUG: Value 1 : ".$value."<br />\n";
           $value = ($value=='all_items') ? '*' : $value;
//echo "DEBUG: Value 2 : ".$value."<br />\n";
           break;
       default :
     }

     $var = $value;
     $_POST[$varname] = $var;
     $_GET[$varname] = $var;
     $_REQUEST[$varname] = $var;
     $v = "&" .$varname. "=$var";

     return $v;
  }

   /**
   * Reverts to the Mambo query string out of the SEF advance URL
   * Input:
   *    $url_array, array, The SEF advance URL split in arrays (first custom virtual directory beginning at $pos+1)
   *    $pos, int, The position of the first virtual directory (component)
   *    $item, int, The item number (position [order] in the list when called function "create()")
   *    $varname, string, The parameter name
   * Output: $QUERY_STRING, string, Mambo query string (&var1=$var1)
   *    Note that this will be added to already defined first part (option=com_example&Itemid=$Itemid)
   **/
   function injectVar (&$url_array, $pos, &$item, &$tsk, &$var, $varname) {

     $QUERY_STRING = "";
     $p = $pos+2+$item;


     if (isset($url_array[$p]) && $url_array[$p]!="" && $p < count($url_array) ) { // param line defined and not empty ?
        // component/example/$var1/
        $value =  $url_array[$p];

// echo "DEBUG: Injecting [".$item."] => [$p:$value] => [$varname]<br />\n";

        if ($varname == "task") {
           $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname);
           $item++;
           $tsk = $value;
        } else {
           switch ($tsk) {

             case "list" :
                 if ( $varname == 'mode' )     { $QUERY_STRING = sef_business_directory::setVar(sef_business_directory::getModeid($value), $var, $varname); $item++; }
                 if ( $varname == 'catid' )    { $QUERY_STRING = sef_business_directory::setVar(sef_business_directory::getCatid($value), $var, $varname); $item++; }
                 if ( $varname == 'navstart' ) { $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname); $item++; }
                 if ( $varname == 'search' )   { $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname); $item++; }
                 if ( $varname == 'msg' )      { $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname); $item++; }
                 break;

             case "view" :
                 if ( $varname == 'id' )       { $QUERY_STRING = sef_business_directory::setVar(sef_business_directory::getBMid($value), $var, $varname); $item++; }
                 break;

             case "check" :
             case "detail" :
             case "edit" :
             case "recommend" :
             case "recommendd" :
             case "send" :
             case "sendd" :
             case "wrapper" :
                 if ( $varname == 'id' )       { $QUERY_STRING = sef_business_directory::setVar(sef_business_directory::getBMid($value), $var, $varname); $item++; }
                 if ( $varname == 'mode' )     { $QUERY_STRING = sef_business_directory::setVar(sef_business_directory::getModeid($value), $var, $varname); $item++; }
                 if ( $varname == 'catid' )    { $QUERY_STRING = sef_business_directory::setVar(sef_business_directory::getCatid($value), $var, $varname); $item++; }
                 if ( $varname == 'navstart' ) { $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname); $item++; }
                 if ( $varname == 'search' )   { $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname); $item++; }
                 break;

             case "order" :
                 if ( $varname == 'mode' )          { $QUERY_STRING = sef_business_directory::setVar(sef_business_directory::getModeid($value), $var, $varname); $item++; }
                 if ( $varname == 'catid' )    { $QUERY_STRING = sef_business_directory::setVar(sef_business_directory::getCatid($value), $var, $varname); $item++; }
                 if ( $varname == "orderbycol" )    { $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname); $item++; }
                 if ( $varname == "orderbyupdown" ) { $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname); $item++; }
                 if ( $varname == 'search' )        { $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname); $item++; }
                 break;

             case "new" :
             case "cancel" :
             case "save" :
                 if ( $varname == 'mode' )     { $QUERY_STRING = sef_business_directory::setVar(sef_business_directory::getModeid($value), $var, $varname); $item++; }
                 if ( $varname == 'catid' )    { $QUERY_STRING = sef_business_directory::setVar(sef_business_directory::getCatid($value), $var, $varname); $item++; }
                 if ( $varname == 'navstart' ) { $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname); $item++; }
                 if ( $varname == 'search' )   { $QUERY_STRING = sef_business_directory::setVar($value, $var, $varname); $item++; }
                 break;

             default :
           }
        }

     }

// echo "DEBUG: Injected [$item] : ".$varname." => ".$QUERY_STRING."<br />\n";

     return $QUERY_STRING;
   }


   // ********************** MAIN FUNCTIONS ****************************

   /**
   * Creates the SEF advance URL out of the Mambo request
   * Input: $string, string, The request URL (index.php?option=com_example&Itemid=$Itemid)
   * Output: $sefstring, string, SEF advance URL ($var1/$var2/)
   **/
   function create ($string) {
      // *** $string == "index.php?option=com_business_directory&Itemid=$Itemid"
      $sefstring = "";
      $tsk = "";
      $item = 0;

      // *** Convert variables to SEF Advance URL Format
      $sefstring .= sef_business_directory::extractVar($string, $tsk, 'task');
      $sefstring .= sef_business_directory::extractVar($string, $tsk, 'id');
      $sefstring .= sef_business_directory::extractVar($string, $tsk, 'mode');
      $sefstring .= sef_business_directory::extractVar($string, $tsk, 'catid');
      $sefstring .= sef_business_directory::extractVar($string, $tsk, 'navstart');
      $sefstring .= sef_business_directory::extractVar($string, $tsk, 'orderbycol');
      $sefstring .= sef_business_directory::extractVar($string, $tsk, 'orderbyupdown');
      $sefstring .= sef_business_directory::extractVar($string, $tsk, 'search');
      $sefstring .= sef_business_directory::extractVar($string, $tsk, 'msg');

// echo "DEBUG: SEF Create : ".$string."<br />\n";
// echo "DEBUG: SEF Create : ".$sefstring."<br />\n";

      // *** $sefstring == "$var1/$var2/"
      return $sefstring;
   }

   /**
   * Reverts to the Mambo query string out of the SEF advance URL
   * Input:
   *    $url_array, array, The SEF advance URL split in arrays (first custom virtual directory beginning at $pos+1)
   *    $pos, int, The position of the first virtual directory (component)
   * Output: $QUERY_STRING, string, Mambo query string (&var1=$var1&var2=$var2)
   *    Note that this will be added to already defined first part (option=com_example&Itemid=$Itemid)
   **/
   function revert (&$url_array, $pos) {
      // *** define all variables you pass as globals

      $QUERY_STRING = "";
      $tsk = "";
      $item = 0;

      // *** Examine the SEF advance URL and extract the variables building the query string
      $QUERY_STRING .= sef_business_directory::injectVar($url_array, $pos, $tsk, $item, $task, 'task');
      $QUERY_STRING .= sef_business_directory::injectVar($url_array, $pos, $tsk, $item, $id, 'id');
      $QUERY_STRING .= sef_business_directory::injectVar($url_array, $pos, $tsk, $item, $mode, 'mode');
      $QUERY_STRING .= sef_business_directory::injectVar($url_array, $pos, $tsk, $item, $catid, 'catid');
      $QUERY_STRING .= sef_business_directory::injectVar($url_array, $pos, $tsk, $item, $navstart, 'navstart');
      $QUERY_STRING .= sef_business_directory::injectVar($url_array, $pos, $tsk, $item, $orderbycol, 'orderbycol');
      $QUERY_STRING .= sef_business_directory::injectVar($url_array, $pos, $tsk, $item, $orderbyupdown, 'orderbyupdown');
      $QUERY_STRING .= sef_business_directory::injectVar($url_array, $pos, $tsk, $item, $search, 'search');
      $QUERY_STRING .= sef_business_directory::injectVar($url_array, $pos, $tsk, $item, $msg, 'msg');

// echo "DEBUG: SEF Revert : ".$QUERY_STRING."<br />\n";
/*
foreach ($url_array as $k=>$v) {
  echo "DEBUG: $k: $v<br />\n";
}
*/

      // *** $QUERY_STRING == "var1=$var1&var2=$var2";
      return $QUERY_STRING;
   }

}
?>